#ifdef HAVE_CONFIG_H
#include <config.h>
#endif

typedef struct t_ldrec {
  /* lambda is x and vice versa */
  real x0;
  real v;
  real T;
  real T_ref;
  real x;
  real m;
  real nu_T;
  real ekin;
  real thetha;
  real v_thetha;
  struct ph_adapt* phc;
  struct lambda_ts* transitions;
  real ph_value;    
  /* needed for three state model */
  real his_partner_const_b; 
  real macro_pka;
  real micro_diff;
};

/* transisiton state array for the sliding window approach
   used in lambda_dynamics 4 */
typedef struct lambda_ts{
    real ts;
    real lambda;
};

/* ph dependence array for the lambda_dynamics 4 */
typedef struct ph_adapt{
    struct ph_adapt* next;
    char* residue;
    real barrier;
    real const_a;
    real const_b;
    real const_2;
    real const_3;
    real ph_a;
    real ph_b;
    real second_pka;
    /* for histidine */
    real param_his[4][5];
};

typedef struct multi_lambda{
  FILE       *out;        /* output file for lambda dynamics data */
  struct t_ldrec *lambda;
  real *chargeA;
  real *chargeB;
  int  *typeA,*typeB;
  real *massA;
  real *massB;
  char *name;
  int residue_number;
  int *atoms;
  int nr_atoms;
  double dvdl;
  struct multi_lambda* next;
  struct multi_lambda* his_partner;
  t_forcerec*  fr_l_dyn;
};

